#include <NTL/ZZ_p.h>
#include <NTL/ZZ.h>
#include <NTL/mat_ZZ_p.h>
#include <NTL/mat_ZZ.h>
#include <NTL/matrix.h>

int main(void)
{
  int i, j, rows, cols;
  ZZ p;
  cin >> p >> rows >> cols;
  
  ZZ_p::init(p);
  ZZ_p temp;
  mat_ZZ_p A;
  mat_ZZ_p ker;
  A.SetDims(rows, cols);
  for (i = 0; i < rows; i++){
    for (j = 0; j < cols; j++){
      cin >> temp;
      A[i][j] = temp;
    }
  }

  kernel(ker, transpose(A));
  
  if (ker.NumRows() == 0){
    cout << "return [];\n";
  }
  else{
    cout << "return [";
    for (i = 0; i < ker.NumRows(); i++){
      cout << "[ ";
      for (j = 0; j < ker.NumCols(); j++){
	cout << ker[i][j];
	if (j != ker.NumCols() - 1 )
	  cout << ", ";
      }
      if (i != ker.NumRows() - 1)
	cout << "],\n";
    }
    cout << "]];\n";
  }
}
  
  
